VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   6690
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "Kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "Kernel32" (lpPerformanceCount As Currency) As Long

Private Running As Boolean

Private Ticks_Per_Second As Currency
Private Start_Time As Currency
Private Time_To_Execute As Single
Private Milliseconds_To_Execute As Single
Private Time_Held(14) As Single
Private Milliseconds_Held As Single
Private Last_Time_Held As Long
Private Tick As Boolean

Private DirectX8 As New DirectX8
Private Direct_Input As DirectInput8

Private Keyboard_Device As DirectInputDevice8
Private Keyboard_State As DIKEYBOARDSTATE

Private Key_Held_Flag(14) As Boolean
Private Key_Press_Flag(14) As Boolean
Private Motion_Control_String As String, Charge_Control_String As String, Control_String As String
Private Move_List(20) As String
Private Number_Of_Moves As Long

Dim I As Long


Private Function Hi_Res_Timer_Initialize() As Boolean

    If QueryPerformanceFrequency(Ticks_Per_Second) = 0 Then

        Hi_Res_Timer_Initialize = False
        
    Else

        QueryPerformanceCounter Start_Time
        Hi_Res_Timer_Initialize = True

    End If

End Function

Private Function Get_Elapsed_Time() As Single

    Dim Last_Time As Currency
    Dim Current_Time As Currency
    
    QueryPerformanceCounter Current_Time
    Get_Elapsed_Time = (Current_Time - Last_Time) / Ticks_Per_Second
    QueryPerformanceCounter Last_Time

End Function

Private Function Lock_FPS(ByVal Target_FPS As Byte) As Single

    If Target_FPS = 0 Then Target_FPS = 1
    
    Static Last_Time As Currency
    Dim Current_Time As Currency
    Dim FPS As Single
    
    Do
    
        QueryPerformanceCounter Current_Time
        FPS = Ticks_Per_Second / (Current_Time - Last_Time)
        
    Loop While (FPS > Target_FPS)
    
    QueryPerformanceCounter Last_Time

End Function


Private Sub DirectInput_Initialize_Keyboard(Window As Form)
    
    Set Direct_Input = DirectX8.DirectInputCreate
    Set Keyboard_Device = Direct_Input.CreateDevice("GUID_SysKeyboard")
    Keyboard_Device.SetCommonDataFormat DIFORMAT_KEYBOARD
    Keyboard_Device.SetCooperativeLevel Window.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    Keyboard_Device.Acquire
    Keyboard_Device.GetDeviceStateKeyboard Keyboard_State

End Sub

Private Function DirectInput_Key_State(Key_Code As Long) As Long

    Keyboard_Device.GetDeviceStateKeyboard Keyboard_State
    DirectInput_Key_State = Keyboard_State.Key(Key_Code)

End Function

Private Sub Control()

    Dim I As Long
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 And _
       DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(0) = True
        If Key_Press_Flag(0) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "N"
            Motion_Control_String = Right(Motion_Control_String, 32) & "N"
            Charge_Control_String = ""
            Key_Press_Flag(0) = True
            Last_Time_Held = 0
        End If
        Time_Held(0) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(0) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(0)))
                Charge_Control_String = ""
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "N" & CStr(Last_Time_Held), "N" & CStr(Int(Time_Held(0))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(0) = False
        Key_Press_Flag(0) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) <> 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 Then
        Key_Held_Flag(1) = True
        If Key_Press_Flag(1) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "U"
            Motion_Control_String = Right(Motion_Control_String, 32) & "U"
            Charge_Control_String = Right(Charge_Control_String, 32) & "U"
            Key_Press_Flag(1) = True
            Last_Time_Held = 0
        End If
        Time_Held(1) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(1) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(1)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "U" & CStr(Last_Time_Held), "U" & CStr(Int(Time_Held(1))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(1) = False
        Key_Press_Flag(1) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) <> 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 Then
        Key_Held_Flag(2) = True
        If Key_Press_Flag(2) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "D"
            Motion_Control_String = Right(Motion_Control_String, 32) & "D"
            Charge_Control_String = Right(Charge_Control_String, 32) & "D"
            Key_Press_Flag(2) = True
            Last_Time_Held = 0
        End If
        Time_Held(2) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(2) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(2)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "D" & CStr(Last_Time_Held), "D" & CStr(Int(Time_Held(2))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(2) = False
        Key_Press_Flag(2) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) <> 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 Then
        Key_Held_Flag(3) = True
        If Key_Press_Flag(3) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "B"
            Motion_Control_String = Right(Motion_Control_String, 32) & "B"
            Charge_Control_String = Right(Charge_Control_String, 32) & "B"
            Key_Press_Flag(3) = True
            Last_Time_Held = 0
        End If
        Time_Held(3) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(3) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(3)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "B" & CStr(Last_Time_Held), "B" & CStr(Int(Time_Held(3))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(3) = False
        Key_Press_Flag(3) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) <> 0 Then
        Key_Held_Flag(4) = True
        If Key_Press_Flag(4) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "F"
            Motion_Control_String = Right(Motion_Control_String, 32) & "F"
            Charge_Control_String = Right(Charge_Control_String, 32) & "F"
            Key_Press_Flag(4) = True
            Last_Time_Held = 0
        End If
        Time_Held(4) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(4) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(4)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "F" & CStr(Last_Time_Held), "F" & CStr(Int(Time_Held(4))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(4) = False
        Key_Press_Flag(4) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) <> 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) <> 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 Then
        Key_Held_Flag(5) = True
        If Key_Press_Flag(5) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "(U+B)"
            Motion_Control_String = Right(Motion_Control_String, 32) & "(U+B)"
            Charge_Control_String = Right(Charge_Control_String, 32) & "(U+B)"
            Key_Press_Flag(5) = True
            Last_Time_Held = 0
        End If
        Time_Held(5) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(5) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(5)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "(U+B)" & CStr(Last_Time_Held), "(U+B)" & CStr(Int(Time_Held(5))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(5) = False
        Key_Press_Flag(5) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) <> 0 And DirectInput_Key_State(DIK_NUMPAD5) = 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) <> 0 Then
        Key_Held_Flag(6) = True
        If Key_Press_Flag(6) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "(U+F)"
            Motion_Control_String = Right(Motion_Control_String, 32) & "(U+F)"
            Charge_Control_String = Right(Charge_Control_String, 32) & "(U+F)"
            Key_Press_Flag(6) = True
            Last_Time_Held = 0
        End If
        Time_Held(6) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(6) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(6)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "(U+F)" & CStr(Last_Time_Held), "(U+F)" & CStr(Int(Time_Held(6))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(6) = False
        Key_Press_Flag(6) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) <> 0 And DirectInput_Key_State(DIK_NUMPAD4) <> 0 And DirectInput_Key_State(DIK_NUMPAD6) = 0 Then
        Key_Held_Flag(7) = True
        If Key_Press_Flag(7) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "(D+B)"
            Motion_Control_String = Right(Motion_Control_String, 32) & "(D+B)"
            Charge_Control_String = Right(Charge_Control_String, 32) & "(D+B)"
            Key_Press_Flag(7) = True
            Last_Time_Held = 0
        End If
        Time_Held(7) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(7) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(7)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "(D+B)" & CStr(Last_Time_Held), "(D+B)" & CStr(Int(Time_Held(7))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(7) = False
        Key_Press_Flag(7) = False
    End If
    
    If DirectInput_Key_State(DIK_NUMPAD8) = 0 And DirectInput_Key_State(DIK_NUMPAD5) <> 0 And DirectInput_Key_State(DIK_NUMPAD4) = 0 And DirectInput_Key_State(DIK_NUMPAD6) <> 0 Then
        Key_Held_Flag(8) = True
        If Key_Press_Flag(8) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "(D+F)"
            Motion_Control_String = Right(Motion_Control_String, 32) & "(D+F)"
            Charge_Control_String = Right(Charge_Control_String, 32) & "(D+F)"
            Key_Press_Flag(8) = True
            Last_Time_Held = 0
        End If
        Time_Held(8) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(8) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(8)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "(D+F)" & CStr(Last_Time_Held), "(D+F)" & CStr(Int(Time_Held(8))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(8) = False
        Key_Press_Flag(8) = False
    End If

    If DirectInput_Key_State(DIK_A) <> 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(9) = True
        If Key_Press_Flag(9) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "LP"
            Motion_Control_String = Right(Motion_Control_String, 32) & "LP"
            Charge_Control_String = Right(Charge_Control_String, 32) & "LP"
            Key_Press_Flag(9) = True
            Last_Time_Held = 0
        End If
        Time_Held(9) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(9) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(9)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "LP" & CStr(Last_Time_Held), "LP" & CStr(Int(Time_Held(9))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(9) = False
        Key_Press_Flag(9) = False
    End If

    If DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) <> 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(10) = True
        If Key_Press_Flag(10) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "MP"
            Motion_Control_String = Right(Motion_Control_String, 32) & "MP"
            Charge_Control_String = Right(Charge_Control_String, 32) & "MP"
            Key_Press_Flag(10) = True
            Last_Time_Held = 0
        End If
        Time_Held(10) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(10) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(10)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "MP" & CStr(Last_Time_Held), "MP" & CStr(Int(Time_Held(10))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(10) = False
        Key_Press_Flag(10) = False
    End If
    
    If DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) <> 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(11) = True
        If Key_Press_Flag(11) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "HP"
            Motion_Control_String = Right(Motion_Control_String, 32) & "HP"
            Charge_Control_String = Right(Charge_Control_String, 32) & "HP"
            Key_Press_Flag(11) = True
            Last_Time_Held = 0
        End If
        Time_Held(11) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(11) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(11)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "HP" & CStr(Last_Time_Held), "HP" & CStr(Int(Time_Held(11))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(11) = False
        Key_Press_Flag(11) = False
    End If
    
    If DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) <> 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(12) = True
        If Key_Press_Flag(12) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "LK"
            Motion_Control_String = Right(Motion_Control_String, 32) & "LK"
            Charge_Control_String = Right(Charge_Control_String, 32) & "LK"
            Key_Press_Flag(12) = True
            Last_Time_Held = 0
        End If
        Time_Held(12) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(12) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(12)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "LK" & CStr(Last_Time_Held), "LK" & CStr(Int(Time_Held(12))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(12) = False
        Key_Press_Flag(12) = False
    End If

    If DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) <> 0 And DirectInput_Key_State(DIK_C) = 0 Then
        Key_Held_Flag(13) = True
        If Key_Press_Flag(13) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "MK"
            Motion_Control_String = Right(Motion_Control_String, 32) & "MK"
            Charge_Control_String = Right(Charge_Control_String, 32) & "MK"
            Key_Press_Flag(13) = True
            Last_Time_Held = 0
        End If
        Time_Held(13) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(13) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(13)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "MK" & CStr(Last_Time_Held), "MK" & CStr(Int(Time_Held(13))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(13) = False
        Key_Press_Flag(13) = False
    End If
    
    If DirectInput_Key_State(DIK_A) = 0 And DirectInput_Key_State(DIK_S) = 0 And DirectInput_Key_State(DIK_D) = 0 And _
       DirectInput_Key_State(DIK_Z) = 0 And DirectInput_Key_State(DIK_X) = 0 And DirectInput_Key_State(DIK_C) <> 0 Then
        Key_Held_Flag(14) = True
        If Key_Press_Flag(14) = False Then
            Milliseconds_To_Execute = Get_Elapsed_Time
            Milliseconds_Held = Get_Elapsed_Time
            Control_String = Right(Control_String, 32) & "HK"
            Motion_Control_String = Right(Motion_Control_String, 32) & "HK"
            Charge_Control_String = Right(Charge_Control_String, 32) & "HK"
            Key_Press_Flag(14) = True
            Last_Time_Held = 0
        End If
        Time_Held(14) = Get_Elapsed_Time - Milliseconds_Held
        If Time_Held(14) >= Last_Time_Held + 1 Then
            If Last_Time_Held = 0 Then
                Control_String = Right(Control_String, 32) & CStr(Int(Time_Held(14)))
                Charge_Control_String = Right(Charge_Control_String, 32) & "C"
            ElseIf Last_Time_Held >= 1 Then
                Control_String = Replace(Control_String, "HK" & CStr(Last_Time_Held), "HK" & CStr(Int(Time_Held(14))))
            End If
            Last_Time_Held = Last_Time_Held + 1
        End If
    Else
        Key_Held_Flag(14) = False
        Key_Press_Flag(14) = False
    End If

    For I = 0 To Number_Of_Moves - 1
        If InStr(1, Motion_Control_String, Mid(Move_List(I), 1, 1)) Then
            Time_To_Execute = Get_Elapsed_Time - Milliseconds_To_Execute
            If Time_To_Execute >= 0.1 Then Motion_Control_String = ""
        End If
    Next I

End Sub

Private Sub Check_Moves()

    '-----------------------------------------------------
    'Haduken
    '-----------------------------------------------------
    If InStr(1, Motion_Control_String, Move_List(0)) Then
        MsgBox "Haduken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(1)) Then
        MsgBox "Haduken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(2)) Then
        MsgBox "Haduken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    '-----------------------------------------------------
    'Shoryuken
    '-----------------------------------------------------
    If InStr(1, Motion_Control_String, Move_List(3)) Then
        MsgBox "Shoryuken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(4)) Then
        MsgBox "Shoryuken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(5)) Then
        MsgBox "Shoryuken"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    '-----------------------------------------------------
    'Hurricane Kick
    '-----------------------------------------------------
    If InStr(1, Motion_Control_String, Move_List(6)) Then
        MsgBox "Hurricane Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(7)) Then
        MsgBox "Hurricane Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Motion_Control_String, Move_List(8)) Then
        MsgBox "Hurricane Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    '-----------------------------------------------------
    'Sonic Boom
    '-----------------------------------------------------
    If InStr(1, Charge_Control_String, Move_List(9)) And Time_Held(3) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If

    If InStr(1, Charge_Control_String, Move_List(10)) And Time_Held(3) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Charge_Control_String, Move_List(11)) And Time_Held(3) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    '-----------------------------------------------------
    'Sonic Boom (Alternate)
    '-----------------------------------------------------
    If InStr(1, Charge_Control_String, Move_List(12)) And Time_Held(7) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Charge_Control_String, Move_List(13)) And Time_Held(7) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Charge_Control_String, Move_List(14)) And Time_Held(7) >= 2 Then
        MsgBox "Sonic Boom"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    '-----------------------------------------------------
    'Flash Kick
    '-----------------------------------------------------
    If InStr(1, Charge_Control_String, Move_List(15)) And Time_Held(2) >= 2 Then
        MsgBox "Flash Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Charge_Control_String, Move_List(16)) And Time_Held(2) >= 2 Then
        MsgBox "Flash Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If
    
    If InStr(1, Charge_Control_String, Move_List(17)) And Time_Held(2) >= 2 Then
        MsgBox "Flash Kick"
        Motion_Control_String = ""
        Charge_Control_String = ""
    End If

End Sub

Private Sub Main()

    With frmMain
    
        .ScaleMode = 3
        .AutoRedraw = True
        
    End With
    
    'Haduken
    Move_List(0) = "D(D+F)FLP"
    Move_List(1) = "D(D+F)FMP"
    Move_List(2) = "D(D+F)FHP"
    
    'Shoryuken
    Move_List(3) = "FND(D+F)LP"
    Move_List(4) = "FND(D+F)MP"
    Move_List(5) = "FND(D+F)HP"
    
    'Hurricane Kick
    Move_List(6) = "D(D+B)BLK"
    Move_List(7) = "D(D+B)BMK"
    Move_List(8) = "D(D+B)BHK"
    
    'Sonic Boom
    Move_List(9) = "BCFLP"
    Move_List(10) = "BCFMP"
    Move_List(11) = "BCFHP"
    
    'Sonic Boom (Alternate)
    Move_List(12) = "(D+B)C(D+F)FLP"
    Move_List(13) = "(D+B)C(D+F)FMP"
    Move_List(14) = "(D+B)C(D+F)FHP"
    
    'Flash Kick
    
    Move_List(15) = "DCULK"
    Move_List(16) = "DCUMK"
    Move_List(17) = "DCUHK"
    
    Number_Of_Moves = 20
    
    DirectInput_Initialize_Keyboard frmMain
    Hi_Res_Timer_Initialize
    Milliseconds_To_Execute = Get_Elapsed_Time
    Milliseconds_Held = Get_Elapsed_Time
    Running = True
    Game_Loop

End Sub

Private Sub Game_Loop()

    Do While Running = True
    
        DoEvents
        Cls
        Lock_FPS 60
        Control
        Print Control_String
        'Print Motion_Control_String
        'Print Charge_Control_String
        Print
        Print "Controls - Press Numpad 8, 5, 4, 6 for Up, Down, Forward, Backward"
        Print
        Print "Motion Moves - Must be done in under 0.1 second!"
        Print "---------------------------------------------------"
        Print "Haduken - D, (D+F), F and any punch button"
        Print "Shoryuken - F, N, D, (D+F) and any punch button"
        Print "Hurrican Kick - D, (D+B), B and any kick button"
        Print
        Print "Charge Moves"
        Print "---------------------------------------------------"
        Print "Sonic Boom - Charge B 2 Seconds, F and any punch button"
        Print "(*Alternate) - Charge (D+B) 2 Seconds, F and any punch button"
        Print "Flash Kick - Charge D 2 Seconds, U and any kick button"
        Check_Moves
        QueryPerformanceCounter Start_Time
    
    Loop

End Sub

Private Sub Form_Load()

    Me.Show
    Main

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Running = False
    Unload Me
    End

End Sub
